(function($) {
    $.fn.sortedList = function(action, key, value) {
        var ul = $(this);

        if (action == "add") {
            var items = ul.children("li");
            for (var i = 0; i < items.length; i++) {
                if ($(items[i]).data('key') == key) {
                    return;
                }
            }

            var item = $('<li>').data('key', key)
                    .append('<span class="aui-icon aui-icon-small aui-iconfont-remove-label">x</span>').append(value);
            item.on("click", function() {
                $(this).remove();
            });
            ul.append(item);
            sortList();
        }
        else if (action == "val") {
            var result = [];
            ul.children("li").each(function() {
                result.push($(this).data('key'));
            });
            return result.join(',');
        }

        function sortList() {
            var items = ul.children("li").get();
            items.sort(function(a,b){
                var keyA = $(a).text().toLowerCase();
                var keyB = $(b).text().toLowerCase();
                return (keyA.localeCompare(keyB));
            });
            $.each(items, function(i, li) {
                ul.append(li);
            });
        };
    }
}($));
