AJS.toInit(function() {
    var urlPrefix = AJS.contextPath() + "/plugins/ultimate-permission-manager/who-can-view/";

    function WhoCanView($container, params) {
        var jobId;

        $container.html("<span class='aui-icon aui-icon-wait'></span> Who can view macro is loading user list...");
        MIUPMJS.post(urlPrefix + 'init-evaluator.action', params, {errorMessage: 'Failed evaluating permissions!'})
                .done(function(data, textStatus, jqXHR) {
                    if (data.status == "success") {
                        jobId = data.jobId;
                        setTimeout(poll(jobId), 100);
                    }
                    else {
                        $container.html("Who can view macro failed! See server logs!");
                    }
                })
                .fail(function(jqXHR, textStatus, errorThrown) {
                    $container.html("Who can view macro failed! " + (jqXHR.status == 400 ? jqXHR.responseText : "See server logs!"));
                })

        var poll = function(jobId) {
            MIUPMJS.get(urlPrefix + 'poll.action', {jobId: jobId})
                    .done(function(data, textStatus, jqXHR) {
                        if (data.done) {
                            download(jobId);
                        }
                        else {
                            setTimeout(poll(jobId), 250);
                        }
                    })
                    .fail(function(jqXHR, textStatus, errorThrown) {
                        $container.html("Who can view macro failed! See server logs!");
                    })
        }

        var download = function(jobId) {
            MIUPMJS.get(urlPrefix + 'download.action', {jobId: jobId})
                    .done(function(data, textStatus, jqXHR) {
                        showResults(data);
                    })
                    .fail(function() {
                        $container.html("Who can view macro failed! See server logs!");
                    })
        }

        var showResults = function(data) {
            var table = $("<table class='who-can-view-table'>"
                    + "<thead><tr><th>Username</th><th>User</th></tr></thead>"
                    + "<tbody></tbody></table>");
            $container.empty().append(table);

            st = table.stream_table(
                    {
                        view: function(owner) {
                            return "<tr><td>" + AJS.escapeHtml(owner.name) + "</td><td>"
                                    + (owner.anonymous ? "" : AJS.escapeHtml(owner.displayName)) + "</td></tr>";
                        },
                        render_no_rows: function() {
                            return "<tr><td colspan='2'><i>No users to show.</i></td></tr>";
                        },
                        init_search_box: function() {
                            return '<form class="st_search_container aui">Filter users: <input name="search" type="text" class="text"></form>';
                        },
                        pagination: {
                            span: 10,
                            per_page: 10,
                            per_page_opts: [10, 25, 50, 100, 250, 500],
                            next_text: 'Next',
                            prev_text: 'Prev'
                        },
                        summary: {
                            unfiltered_template: "{FROM} to {TO} of {TOTAL} entries",
                            filtered_template: "{FROM} to {TO} of {TOTAL} entries (of total {TOTAL_UNFILTERED} unfiltered)"
                        }
                    },
                    data.owners);

            console.log("Who can view macro evaluation time: " + data.evaluationTime + " ms");
        }
    }


    $('#who-can-view-button-link').on('click', function(e) {
        e.preventDefault();
        var $macro = $(this);
        var params = {
            spaceKey: AJS.Meta.get('space-key'),
            pageId: AJS.Meta.get('page-id'),
            hideAnonymous: false,
            ignoreRestrictions: false
        }

        this.whoCanViewDialog = new AJS.Dialog({
            width: 640,
            height: 480,
            id: "who-can-view-dialog",
            closeOnOutsideClick: true
            // keypressListener: $.proxy(function(e) {
            //     if (e.keyCode == 27) {
            //         this.closeError();
            //         e.preventDefault();
            //     }
            }, this);

        var $whoCanViewContainer = $('<div></div>')
        new WhoCanView($whoCanViewContainer, params);

        this.whoCanViewDialog.addHeader("Who Can View");
        //this.errorDialogNode.find(".dialog-title").prepend(AJS.CONTENT_EXPORTER.headerAvatarTemplate.clone());

        this.whoCanViewDialog.addButton("OK", $.proxy(function(dialog) {
            dialog.hide();
        }, this));

        this.whoCanViewDialog.addPanel("", $whoCanViewContainer, "panel-body");
        // this.errorDialogNode.find(".error-message").html(msg);
        // this.errorDialogNode.find("#error-details-toggler").click($.proxy(function(e) {
        //     e.preventDefault();
        //     AJS.$("#error-details").toggle();
        //     this.errorDialog.updateHeight();
        // }, this));
        this.whoCanViewDialog.show();

        return false;
    });


    $('.who-can-view-macro').each(function(index) {
        var $macro = $(this);
        var params = {
            spaceKey: $macro.data('space-key'),
            pageId: $macro.data('page-id'),
            hideAnonymous: $macro.data('hide-anonymous'),
            ignoreRestrictions: $macro.data('ignore-restrictions')
        }
        new WhoCanView($macro, params);
    })
});

